<?php



/**

 * PHP versions 4 and 5

 *

 * LICENSE: This source file is subject to version 3.0 of the PHP license

 * that is available through the world-wide-web at the following URI:

 * http://www.php.net/license. If you did not receive a copy of

 * the PHP License and are unable to obtain it through the web, please

 * send a note to license@php.net so we can mail you a copy immediately.

 *

 * @category   Troubleticket

 * @package    QuickTicket

 * @author     Philippe Vandenberghe <info@qt-cute.org>

 * @copyright  2008-2012 The PHP Group

 * @version    2.2 build:20090816

 * @link       http://www.qt-cute.org/doc/package/qti

 * @since      File available since Release 1.0.0

 * @deprecated File deprecated in Release 3.0.0

 */



session_start();

require_once('bin/qti_init.php');

require_once('bin/qti_fn_tags.php');

if ( !$oVIP->CanView('V5') ) HtmlPage(11);



// INITIALISE



$oVIP->selfurl = 'qti_search.php';

$oVIP->selfname = $L['Search'];

$oVIP->exitname = $L['Search'];



$strAction = 'ref';

$s = -1;

$k1 = '';

$k2 = '';

$k3 = '';



if ( isset($_GET['a']) ) $strAction = strip_tags($_GET['a']);

if ( isset($_GET['s']) ) $s = intval($_GET['s']);

if ( isset($_POST['s']) ) $s = intval($_POST['s']);

if ( isset($_POST['s_ref']) ) $s = strip_tags($_POST['s_ref']);

if ( isset($_POST['s_tst']) ) $s = strip_tags($_POST['s_tst']);

if ( isset($_POST['s_kw']) ) $s = strip_tags($_POST['s_kw']);



if ( isset($_GET['k1']) ) $k1 = strip_tags($_GET['k1']);

if ( isset($_POST['k1']) ) $k1 = strip_tags($_POST['k1']);

if ( isset($_GET['k2']) ) $k2 = strip_tags($_GET['k2']);

if ( isset($_POST['k2']) ) $k2 = strip_tags($_POST['k2']);

if ( isset($_GET['k3']) ) $k3 = strip_tags($_GET['k3']);

if ( isset($_POST['k3']) ) $k3 = strip_tags($_POST['k3']);



// --------

// SUBMITTED

// --------



if ( isset($_POST['okref']) )

{

  if ( empty($k1) ) $error = $L['Ref'].' '.$L['E_invalid'];

  if ( empty($error) ) { $oVIP->exiturl = 'qti_search_re.php?a=ref&amp;s='.$s.'&amp;k1='.$k1; $oVIP->EndMessage('0'); exit; }

}

if ( isset($_POST['oktst']) )

{

  if ( $k1=='-' || $k1=='--' || $k2=='-' ) $error = $L['Date'].' & '.$L['Status'].' '.$L['E_invalid'];

  if ( $k1=='-1' && $k2=='-1' && empty($k3) ) $error = $L['Date'].' & '.$L['Status'].' & Tag '.$L['E_invalid'];

  if ( $k3==';' ) $error = 'Tag '.$L['E_invalid'];

  if ( empty($error) ) { $oVIP->exiturl = 'qti_search_re.php?a=tst&amp;s='.$s.'&amp;k1='.$k1.'&amp;y='.intval($_POST['y']).'&amp;k2='.$k2.'&amp;k3='.$k3; $oVIP->EndMessage('0'); exit; }

}

if ( isset($_POST['okkw']) )

{

  if ( empty($k1) ) $error = $L['Keywords'].' '.$L['E_invalid'];

  if ( empty($error) ) { $oVIP->exiturl = 'qti_search_re.php?a=kw&amp;s='.$s.'&amp;k1='.$k1.'&amp;k2='.(isset($_POST['k2']) ? '1' : '0').'&amp;k3='.($k3=='1' ? '1' : '0'); $oVIP->EndMessage('0'); exit; }

}



// --------

// HTML START

// --------



$arrTags = cSection::GetTagsUsed(-1);

if ( count($arrTags)>0 ) $arrTags = TagsDesc($arrTags);

$str  = '';

foreach($arrTags as $strKey=>$strDesc) { $str .= '{n:"'.$strKey.'",d:"'.($strKey==$strDesc ? ' ' : substr($strDesc,0,64)).'"},'; }

$str = substr($str,0,-1);



$strHeadScript = '

<script type="text/javascript" src="bin/qt_jquery.js"></script>

<script type="text/javascript" src="bin/qt_jquery_auto.js"></script>

<script type="text/javascript">

<!--

$(document).ready(function() {

  $("#datav").autocomplete("qti_j_data.php", {

    minChars:2,

    matchContains:true,

    selectFirst: false,

    extraParams: { dataf: function() { return $("#dataf").val(); } }

    });

  $("#tag").autocomplete(['.$str.'],{

    minChars:0,

    matchContains:true,

    width:200,

    multiple:true,

    multipleSeparator:";",

    formatItem: function(row) { return (row.d==" ") ? row.n : (row.n + "<span class=small> - " + row.d + "</span>"); },

    formatResult: function(row) { return row.n; }

    });

});

-->

</script>

';  



$bJava=true;



$oVIP->css[] = 'qt_jquery.css';



include('qti_p_header.php');



// TOP BUTTONS



echo '<table class="button" cellspacing="0">',N;

echo '<tr class="button">',N;

echo '<td>&nbsp;</td>',N;

echo '<td style="width:25px" class="button">',AsImg($_SESSION[QT]['skin_dir'].'/ico_topic_t_0.gif','T',$L['Ico_topic_t_0'],'ico ico_t'),'</td>',N;

echo '<td style="width:120px" class="button">&nbsp;<a href="qti_search_re.php?a=last" class="button">',$L['Recent_messages'],'</a>&nbsp;</td>',N;

echo '<td style="width:10px">&nbsp;</td>',N;

echo '<td style="width:25px" class="button">',AsImg($_SESSION[QT]['skin_dir'].'/ico_topic_a_0.gif','T',$L['Ico_topic_a_0'],'ico ico_t'),'</td>',N;

echo '<td style="width:120px" class="button">&nbsp;<a href="qti_search_re.php?a=news" class="button">',$L['All_news'],'</a>&nbsp;</td>',N;

if ($oVIP->role!='V')

{

echo '<td style="width:10px">&nbsp;</td>',N;

  echo '<td style="width:25px" class="button">',AsImg($_SESSION[QT]['skin_dir'].'/ico_user_p_1.gif','T',$L['Ico_user_p_1'],'ico ico_user'),'</td>',N;

echo '<td style="width:120px" class="button">&nbsp;<a href="qti_search_re.php?a=user&amp;k1=',$oVIP->id,'&amp;k2=',urlencode($oVIP->username),'" class="button">',$L['All_my_topics'],'</a>&nbsp;</td>',N;

}

echo '</tr>',N;

echo '</table>',N;



// SEARCH OPTION



echo '<h2>',$L['Search_option'],'</h2>

<div style="width:500px">

<form method="post" action="',$oVIP->selfurl,'">

<table class="data_s" cellspacing="0">

<tr class="data_s">

<td class="th_s th_s_first th_s_empty"></td>

<td class="th_s th_s_empty"></td>

<td class="th_s th_s_last th_s_empty"></td>

</tr>

<tr class="data_s">

<td class="td_s td_s_ico td_s_first">',AsImg($_SESSION[QT]['skin_dir'].'/ico_section_option.gif','search',$L['Search'],'ico ico_s'),'</td>

<td class="td_s">',$L['Search'],' <select id="s" name="s" size="1" onchange="SearchOption(this.value);">

<option value="-1"',($s=='-1' ? QSEL : ''),'>',$L['In_all_sections'],'</option>';

if ( isset($oSYS) ) {

if ( count($oSYS->sections)>0 ) {

  echo QTasTag($oSYS->sections,$s,array('format'=>$L['Section'].': %s'));

}}

echo '

</select>

<input type="submit" id="o_ok" name="o_ok" value="',$L['Ok'],'"/>

</td>

<td class="td_s"></td>

</tr>

<tr class="tf_s">

<td class="tf_s tf_s_first"></td>

<td class="tf_s"></td>

<td class="tf_s tf_s_last"></td>

</tr>

</table>

</form>

</div>

';



echo '

<h2>',$L['Search_criteria'],'</h2>

';



// ERROR MESSAGE



if ( !empty($error) ) echo '<p class="error">',$error,'</p>';



// SEARCH BY REF



if ( isset($oSYS) ) {

if ( count($oSYS->sections)>0 ) { $arrSections = GetSectionTitles($oVIP->role,-1,-1,'s.numfield<>"N"');

if ( count($arrSections)>0 ) {

echo '<form method="post" action="',$oVIP->selfurl,'">

<table class="data_s" cellspacing="0">

<tr class="data_s">

<td class="th_s th_s_first th_s_empty"></td>

<td class="th_s th_s_empty"></td>

<td class="th_s th_s_last th_s_empty"></td>

</tr>

<tr class="data_s">

<td class="td_s td_s_ico td_s_first">',AsImg($_SESSION[QT]['skin_dir'].'/ico_section_search.gif','search',$L['Search'],'ico ico_s'),'</td>

<td class="td_s">',$L['Ref'],' <input type="text" id="ref" name="k1" size="5" maxlength="10" value="'.($strAction=='ref' ? $k1 : '').'" onkeyup="qtKeypress(event,\'okref\')"/>&nbsp;<span class="small">',$L['H_Reference'],'</span></td>

<td class="td_s" style="padding:7px; text-align:right">

<input type="hidden" id="s_ref" name="s_ref" value="',$s,'"/>

<input type="submit" id="okref" name="okref" value="',$L['Search'],'" onclick="return ValidateForm(\'ref\');"/>

</td>

</tr>

<tr class="tf_s">

<td class="tf_s tf_s_first"></td>

<td class="tf_s"></td>

<td class="tf_s tf_s_last"></td>

</tr>

</table>

</form>

<br/>

';

}}}



// SEARCH BY KEY



echo '<form method="post" action="',$oVIP->selfurl,'">

<table class="data_s" cellspacing="0">

<tr class="data_s">

<td class="th_s th_s_first th_s_empty"></td>

<td class="th_s th_s_empty"></td>

<td class="th_s th_s_last th_s_empty"></td>

</tr>

<tr class="data_s">

<td class="td_s td_s_ico td_s_first">',AsImg($_SESSION[QT]['skin_dir'].'/ico_section_search.gif','search',$L['Search'],'ico ico_s'),'</td>

<td class="td_s">',$L['Keywords'],' <input type="text" id="kw" name="k1" size="40" maxlength="64" value="'.($strAction=='kw' ? $k1 : '').'" onkeyup="qtKeypress(event,\'okkw\')"/>&nbsp;<input type="checkbox" id="to" name="k3"',(empty($k3) ? '' : QCHE),' value="1"/> <label for="to">',$L['In_title_only'],'</label>

</td>

<td class="td_s" style="padding:7px; text-align:right">

<input type="hidden" id="s_kw" name="s_kw" value="',$s,'"/>

<input type="submit" id="okkw" name="okkw" value="',$L['Search'],'" onclick="return ValidateForm(\'kw\');"/>

</td>

</tr>

<tr class="tf_s">

<td class="tf_s tf_s_first"></td>

<td class="tf_s"></td>

<td class="tf_s tf_s_last"></td>

</tr>

</table>

</form>

<br/>

';



// SEARCH BY DATE & STATUS & TAGS



echo '<form method="post" action="',$oVIP->selfurl,'">

<table class="data_s" cellspacing="0">

<tr class="data_s">

<td class="th_s th_s_first th_s_empty"></td>

<td class="th_s th_s_empty"></td>

<td class="th_s th_s_last th_s_empty"></td>

</tr>

<tr class="data_s">

<td class="td_s td_s_ico td_s_first">',AsImg($_SESSION[QT]['skin_dir'].'/ico_section_search.gif','search',$L['Search'],'ico ico_s'),'</td>

<td class="td_s">',$L['Date'],' <select id="ti" name="k1" size="1" class="small">

<option value="w"',($k1=='w' ? QSEL : ''),'>',$L['This_week'],'</option>

<option value="m"',($k1=='m' ? QSEL : ''),'>',$L['This_month'],'</option>

<option value="y"',($k1=='y' ? QSEL : ''),'>',$L['This_year'],'</option>

<option value="-" disabled="disabled">-----------</option>

<option value="-1"',($k1=='-1' ? QSEL : ''),'>',$L['Any_time'],'</option>

<option value="--" disabled="disabled">-----------</option>

',QTasTag($L['dateMMM'],$k1),'

</select><input type="hidden" name="y" value="',date('Y'),'"/>

',$L['Status'],' <select id="st" name="k2" size="1" class="small">

<option value="-1"',($k2=='-1' ? QSEL : ''),'>',$L['Any_status'],'</option>

<option value="-" disabled="disabled">-----------</option>

 ',QTasTag($oSYS->statuses,$k2),'

</select>

 ';

if ( $_SESSION[QT]['tags']!='0' ) echo $L['With_tag'],' <input type="text" id="tag" name="k3" size="30" value="'.($strAction=='tst' ? $k3 : '').'" onkeyup="qtKeypress(event,\'okti\')" class="small"/>*';

echo '</td>

<td class="td_s" style="padding:7px; text-align:right">

<input type="hidden" id="s_tst" name="s_tst" value="',$s,'"/>

<input type="submit" id="oktst" name="oktst" value="',$L['Search'],'"/>

</td>

</tr>

<tr class="tf_s">

<td class="tf_s tf_s_first"></td>

<td class="tf_s"></td>

<td class="tf_s tf_s_last"></td>

</tr>

</table>

</form>

';

if ( $_SESSION[QT]['tags']!='0' ) echo '<p class="small">* ',$L['H_Tag_input'],'</p>';



// HTML END



echo '<script type="text/javascript">

<!--

document.getElementById("o_ok").style.visibility="hidden";

document.getElementById("kw").focus();

function SearchOption(strValue)

{

  if (document.getElementById("s_ref")) document.getElementById("s_ref").value=strValue;

  if (document.getElementById("s_tst")) document.getElementById("s_tst").value=strValue;

  if (document.getElementById("s_kw")) document.getElementById("s_kw").value=strValue;

}

function ValidateForm(strId)

{

  strError = strId;

  if (strId=="kw") strError = "',str_replace('"','',$L['Keywords']),'"; 

  if (document.getElementById(strId).value.length==0) { alert(strError.toUpperCase()+" - "+qtHtmldecode("',$L['E_mandatory'],'")); return false; }

  return null;

}

-->

</script>

';



include('qti_p_footer.php');



?>