<?php

/**
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license. If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Troubleticket
 * @package    QuickTicket
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.2 build:20090816
 * @link       http://www.qt-cute.org/doc/package/qti
 * @since      File available since Release 1.0.0
 * @deprecated File deprecated in Release 3.0.0
 */

session_start();
require_once('bin/qti_init.php');
if ( !$oVIP->CanView('V4') ) HtmlPage(11);
include(Translate('qti_stat.php'));

// --------
// INITIALISE
// --------

$oVIP->selfurl = 'qti_stats.php';
$oVIP->selfname = $L['Statistics'];

$s = -1;   // section filter
$intYear = date('Y'); if ( intval(date('n'))<2 ) $intYear--; // year filter
$tag = ''; // tags filter
$tt = 'g'; // tab: g=global, gt=globaltrend, d=detail, dt=detailtrend

$ch = array('time'=>'m','type'=>'b','value'=>'a','trend'=>'a'); // chart parameters
// blocktime: m=month, q=quarter, d=10days 
// graph type: b=bar, l=line, B=bar+variation, L=line+variation
// graphics reals: a=actual, p=percent
// trends reals: a=actual, p=percent

// --------
// SUBMITTED
// --------
  
if ( isset($_GET['y']) ) $intYear = intval($_GET['y']);
if ( isset($_GET['s']) ) $s = intval($_GET['s']);
if ( $s>=0 ) { $strSection = 'forum='.$s.' AND'; } else { $strSection=''; }
if ( isset($_GET['tag']) ) $tag = strip_tags($_GET['tag']);
  $strTags = '';
  if ( !empty($tag) )
  {
    if ( substr($tag,-1,1)==';' ) $tag = substr($tag,0,-1); 
    $arrTags = explode(';',$tag);
    $str = '';
    foreach($arrTags as $strTag)
    {
    if ( !empty($str) ) $str .= ' OR ';
    $str .= 'UPPER(tags) LIKE "%'.strtoupper($strTag).'%"';
    }
    if ( !empty($str) ) $strTags = ' ('.$str.') AND';
  }
if ( isset($_GET['tt']) ) $tt = strip_tags($_GET['tt']);
if ( isset($_GET['ch']) )
{
  $str = strip_tags($_GET['ch']);
  if ( strlen($str)>0 ) $ch['time'] = substr($str,0,1); // blocktime
  if ( strlen($str)>1 ) $ch['type'] = substr($str,1,1); // graph type
  if ( strlen($str)>2 ) $ch['value'] = substr($str,2,1); // value type
  if ( strlen($str)>3 ) $ch['trend'] = substr($str,3,1); // trends value type
}

if ( $tt=='g' || $tt=='d' ) $ch['type'] = strtolower($ch['type']);

// --------
// INITIALISE RANGES
// --------

if ( $tt=='gt' || $tt=='dt' )
{
$arrYears = array($intYear-1,$intYear); // Normal is 1 year but for Trends analysis, 2 years
}
else
{
$arrYears = array($intYear);
}

$oDB->Query( 'SELECT min(firstpostdate) as startdate, max(firstpostdate) as lastdate FROM '.TABTOPIC );
$row = $oDB->Getrow();
if ( empty($row['startdate']) ) $row['startdate']=strval($intYear-1).'0101';
if ( empty($row['lastdate']) ) $row['lastdate']=strval($intYear).'1231';
$strLastdaysago = substr($row['lastdate'],0,8);
$strTendaysago = DateAdd($strLastdaysago,-10,'day');
$intStartyear = intval(substr($row['startdate'],0,4));
$intStartmonth = intval(substr($row['startdate'],4,2));
$intEndyear = intval(date('Y'));
$intEndmonth = intval(date('n'));

// --------
// HTML START
// --------

$strFilter = 's='.$s.'&amp;y='.$intYear.'&amp;tag='.$tag;

$arrTags = cSection::GetTagsUsed(-1);
$str  = '';
foreach($arrTags as $strName=>$strDesc) { $str .= '{n:"'.$strName.'",d:"'.($strName==$strDesc ? ' ' : substr($strDesc,0,64)).'"},'; }
$str = substr($str,0,-1);

$strHeadScript = '
<script type="text/javascript" src="bin/qt_jquery.js"></script>
<script type="text/javascript" src="bin/qt_jquery_auto.js"></script>
<script type="text/javascript">
<!--
function FlushTag() { $("#tag").flushCache(); }
$(document).ready(function() {
  var arrData = ['.$str.'];
  $("#tag").autocomplete(arrData,{
    minChars:0,
    width:190,
    multiple:true,
    multipleSeparator:";",
    formatItem: function(row) { return (row.d==" ") ? row.n : (row.n + "<span class=small> - " + row.d + "</span>"); },    
    formatResult: function(row) { return row.n; }
    });
});
-->
</script>
'; 

$bJava = false;

$oVIP->css[] = 'qt_jquery.css';
$oVIP->css[] = 'qti_main2.css';

include('qti_p_header.php');

// OPTIONS

echo '<table class="hidden" cellspacing="0">';
echo '<tr class="hidden">';
echo '<td class="hidden"><h1>',$L['Statistics'],'</h1></td>',N;
echo '<td class="hidden">&nbsp;</td>',N;
echo '<td class="hidden" style="width:450px">
<form method="get" action="',$oVIP->selfurl.'">
<div class="legendbox optionstats">
<p class="legendtitle">',$L['Options'],'</p>
';

$arrY = array(); // all possible years 
for ($i=$intStartyear;$i<=$intEndyear;$i++) $arrY[$i]=$i;

if ( $_SESSION[QT]['tags']=='0' )
{
  echo '<p style="text-align:right">',$L['Year'],'&nbsp;<select class="small" name="y" id="y">',QTasTag($arrY,$intYear),'</select> ';
  if ( count($oSYS->sections)>0 ) echo  $L['Section'],'&nbsp;<select class="small" name="s" id="s"><option value="-1">'.$L['In_all_sections'].'</option>'.QTasTag($oSYS->sections,$s).'</select> ';
  echo '<input type="hidden" name="ch" value="',implode('',$ch),'"/><input type="hidden" name="tt" value="',$tt,'"/><input type="submit" name="ok" class="small" value="',$L['Ok'],'"/>&nbsp;</p>';
}
else
{
  echo '<table class="hidden">
  <tr class="hidden">
  <td class="hidden">',$L['Year'],'</td>
  <td class="hidden">',(count($oSYS->sections)>0 ? $L['Section'] : '&nbsp;'),'</td>
  <td class="hidden">',$L['Tag'],'</td>
  <td class="hidden">&nbsp;</td>
  </tr>
  <tr class="hidden">
  <td class="hidden"><input type="hidden" name="tt" value="',$tt,'"/><select class="small" name="y" id="y">',QTasTag($arrY,$intYear),'</select></td>
  <td class="hidden">',(count($oSYS->sections)>0 ? '<select class="small" name="s" id="s"><option value="-1">'.$L['In_all_sections'].'</option>'.QTasTag($oSYS->sections,$s).'</select>' : '&nbsp;'),'</td>
  <td class="hidden"><input class="small" type="text" id="tag" name="tag" size="20" value="',$tag,'"/></td>
  <td class="hidden"><input type="hidden" name="ch" value="',implode('',$ch),'"/><input type="submit" name="ok" class="small" value="',$L['Ok'],'"/></td>
  </tr>
  </table>';
}
echo '
</p>
</div>
</form>
</td>
</tr>
</table>
';

// STATISTIC TABS and GRAPHIC MENUS definition

$arrTabs = array();
$arrTabs['g'] = array('tabname'=>$L['Global'],'tabdesc'=>$L['H_Global']);
$arrTabs['gt'] = array('tabname'=>$L['Global_trends'],'tabdesc'=>$L['H_Global_trends']);
$arrTabs['d'] = array('tabname'=>$L['Details'],'tabdesc'=>$L['H_Details']);
$arrTabs['dt'] = array('tabname'=>$L['Details_trends'],'tabdesc'=>$L['H_Details_trends']);

$arrMenuTime = array(); // Block time: q=quarter, m=month, d=10days
if ( $ch['time']=='q' ) { $arrMenuTime[]=$L['Per_q']; } else { $arr=$ch; $arr['time']='q'; $arrMenuTime[]='<a href="'.$oVIP->selfurl.'?tt='.$tt.'&amp;'.$strFilter.'&amp;ch='.implode('',$arr).'" class="small">'.$L['Per_q'].'</a>'; }
if ( $ch['time']=='m' ) { $arrMenuTime[]=$L['Per_m']; } else { $arr=$ch; $arr['time']='m'; $arrMenuTime[]='<a href="'.$oVIP->selfurl.'?tt='.$tt.'&amp;'.$strFilter.'&amp;ch='.implode('',$arr).'" class="small">'.$L['Per_m'].'</a>'; }
if ( $ch['time']=='d' ) { $arrMenuTime[]=$L['Per_d']; } else { $arr=$ch; $arr['time']='d'; $arrMenuTime[]='<a href="'.$oVIP->selfurl.'?tt='.$tt.'&amp;'.$strFilter.'&amp;ch='.implode('',$arr).'" class="small">'.$L['Per_d'].'</a>'; }

$arrMenuType = array(); // Chart tyle: b=bar, l=line, B=bar+variation labels, L=line+variation labels
if ( $ch['type']=='b' ) { $arrMenuType[]=$L['Chart_bar']; }  else { $arr=$ch; $arr['type']='b'; $arrMenuType[]='<a href="'.$oVIP->selfurl.'?tt='.$tt.'&amp;'.$strFilter.'&amp;ch='.implode('',$arr).'" class="small">'.$L['Chart_bar'].'</a>'; }
if ( $tt=='gt' || $tt=='dt' )
{
if ( $ch['type']=='B' ) { $arrMenuType[]=$L['Chart_bar_var']; }  else { $arr=$ch; $arr['type']='B'; $arrMenuType[]='<a href="'.$oVIP->selfurl.'?tt='.$tt.'&amp;'.$strFilter.'&amp;ch='.implode('',$arr).'" class="small">'.$L['Chart_bar_var'].'</a>'; }
}
if ( $ch['type']=='l' ) { $arrMenuType[]=$L['Chart_line']; } else { $arr=$ch; $arr['type']='l'; $arrMenuType[]='<a href="'.$oVIP->selfurl.'?tt='.$tt.'&amp;'.$strFilter.'&amp;ch='.implode('',$arr).'" class="small">'.$L['Chart_line'].'</a>'; }
if ( $tt=='gt' || $tt=='dt' )
{
if ( $ch['type']=='L' ) { $arrMenuType[]=$L['Chart_line_var']; } else { $arr=$ch; $arr['type']='L'; $arrMenuType[]='<a href="'.$oVIP->selfurl.'?tt='.$tt.'&amp;'.$strFilter.'&amp;ch='.implode('',$arr).'" class="small">'.$L['Chart_line_var'].'</a>'; }
}

$arrMenuValue = array(); // Value type: a=actual, p=percent
if ( $ch['value']=='a' ) { $arrMenuValue[]=$L['Per_a']; } else { $arr=$ch; $arr['value']='a'; $arrMenuValue[]='<a href="'.$oVIP->selfurl.'?tt='.$tt.'&amp;'.$strFilter.'&amp;ch='.implode('',$arr).'" class="small">'.$L['Per_a'].'</a>'; }
if ( $ch['value']=='p' ) { $arrMenuValue[]=$L['Per_p']; } else { $arr=$ch; $arr['value']='p'; $arrMenuValue[]='<a href="'.$oVIP->selfurl.'?tt='.$tt.'&amp;'.$strFilter.'&amp;ch='.implode('',$arr).'" class="small">'.$L['Per_p'].'</a>'; }

$arrMenuTrend = array(); // Trend value type: a=actual, p=percent
if ( $ch['trend']=='a' ) { $arrMenuTrend[]=$L['Per_a']; } else { $arr=$ch; $arr['trend']='a'; $arrMenuTrend[]='<a href="'.$oVIP->selfurl.'?tt='.$tt.'&amp;'.$strFilter.'&amp;ch='.implode('',$arr).'" class="small">'.$L['Per_a'].'</a>'; }
if ( $ch['trend']=='p' ) { $arrMenuTrend[]=$L['Per_p']; } else { $arr=$ch; $arr['trend']='p'; $arrMenuTrend[]='<a href="'.$oVIP->selfurl.'?tt='.$tt.'&amp;'.$strFilter.'&amp;ch='.implode('',$arr).'" class="small">'.$L['Per_p'].'</a>'; }

echo HtmlTabs($arrTabs, $oVIP->selfurl.'?'.$strFilter.'&amp;ch='.implode('',$ch), $tt);

echo '<table class="pan" cellspacing="0">
<tr class="pan">
<td class="pan">
<div class="pan_top">',$arrTabs[$tt]['tabdesc'],'</div>
';

switch($tt)
{
case 'g': include('qti_stats_g.php'); break;
case 'gt': include('qti_stats_gt.php'); break;
case 'd': include('qti_stats_d.php'); break;
case 'dt': include('qti_stats_dt.php'); break;
default: die('Invalid tab');
}

echo '
</td>
</tr>
</table>
';

// CSV

if ( file_exists('qti_stats_'.$tt.'_csv.php') )
{
  echo '<p style="margin:2px;text-align:right"><a href="qti_stats_'.$tt.'_csv.php?tt='.$tt.'&amp;'.$strFilter.'&amp;ch='.implode('',$ch).'">csv</a></p>';
}

// HTML END

include('qti_p_footer.php');

?>