<?php

/**
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license. If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Troubleticket
 * @package    QuickTicket
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.2 build:20090816
 * @link       http://www.qt-cute.org/doc/package/qti
 * @since      File available since Release 1.0.0
 * @deprecated File deprecated in Release 3.0.0
 */

session_start();
require_once('bin/qti_init.php');
if ( !$oVIP->CanView('V2') ) HtmlPage(11);
include('bin/qti_fn_sql.php');

$s = -1;
if ( isset($_GET['s']) ) $s = intval(strip_tags($_GET['s']));
if ( isset($_POST['s']) ) $s = intval(strip_tags($_POST['s']));
if ( $s<0 ) die('Missing section id...');

// ---------
// SUBMITTED
// ---------

if ( isset($_POST['Mok']) )
{
  if ( $_POST['Maction']=='nt' )
  {
    if ( headers_sent() )
    {
    echo '<a href="qti_form_edit.php?s=',$s,'&amp;a=nt">',$L['Post_new_topic'],'</a><meta http-equiv="REFRESH" content="0;url=qti_form_edit.php?s=',$s,'&amp;a=nt">';
    }
    else
    {
    header('Location: qti_form_edit.php?s='.$s.'&a=nt');
    }
    exit;
  }
  if ( $_POST['Maction']=='show_Z' ) $_SESSION[QT]['show_closed']='1';
  if ( $_POST['Maction']=='hide_Z' ) $_SESSION[QT]['show_closed']='0';
  if ( $_POST['Maction']=='print' )
  {
    echo 'No yet developped';
    exit;
  }
  if ( $_POST['d_last']!='-' )
  {
    $_SESSION[QT]['lastcolumn']=$_POST['d_last']; // can be 'none'
  }
}

// ---------
// INITIALISE
// ---------

$oSEC = new cSection($s);

if ( $oSEC->type==1 && ($oVIP->role=='V' || $oVIP->role=='U') )
{
  // exit
  $oVIP->selfname = $L['Section'];
  $oVIP->exitname = ObjTrans('index','i',$_SESSION[QT]['index_name']);
  $oVIP->EndMessage(NULL,$L['R_staff'],$_SESSION[QT]['skin_dir'],0);
}
if ( $oSEC->type==2 && $oVIP->role=='V' )
{
  // exit
  $oVIP->selfname = $L['Section'];
  $oVIP->exitname = ObjTrans('index','i',$_SESSION[QT]['index_name']);
  $oVIP->EndMessage(NULL,$L['R_member'],$_SESSION[QT]['skin_dir'],0);
}

$oVIP->selfurl = 'qti_topics.php';
$oVIP->selfname = $L['Section'].': '.$oSEC->name;

$strCommand = '';
$numid = '';
$arrMe[] = array();

$strOrder = 'lastpostdate';
$strDirec = 'DESC';
$intPage = 1;
$intLimit = 0;
if ( isset($_GET['page']) ) { $intLimit = (intval($_GET['page'])-1)*$_SESSION[QT]['topics_per_page']; $intPage = intval($_GET['page']); }
if ( isset($_GET['order']) ) $strOrder = $_GET['order'];
if ( isset($_GET['dir']) ) $strDirec = $_GET['dir'];

// MAP MODULE

if ( UseModule('map') ) { $strCheck=$s; include('qtim_map_ini.php'); } else { $bMap=false; }

// --------
// HTML START
// --------

$strHeadScript = '
<script type="text/javascript" src="bin/qt_jquery.js"></script>
<script type="text/javascript">
<!--
$(document).ready(function() {
  $(".tag").hover(function() {
    var oTag = $(this);
    $.post("qti_j_tag.php",{s:"'.$s.'",val:oTag.html(),lang:"'.$_SESSION[QT]['lang_iso'].'",na:"..."}, function(data) { oTag.attr({title:data}); } );
    });
  });
-->
</script>
';

$bJava = false;
include('qti_p_header.php');

// SECTION OPTIONS

if ( $oSEC->status==1 )
{
  $strCommand = '<td class="button" style="width:120px"><span class="button_off">&nbsp;'.$L['E_section_closed'].'&nbsp;</span></td>';
}
else
{
  $strCommand = '<td class="button" style="width:120px">&nbsp;<a class="button" href="qti_form_edit.php?s='.$oSEC->id.'&amp;a=nt">'.$L['Post_new_topic'].'</a>&nbsp;</td>';
  if ( $oVIP->role=='V' && $_SESSION[QT]['visitor_right']<7 )
  {
  $strCommand = '<td class="button" style="width:120px"><span class="button_off">&nbsp;'.$L['Post_new_topic'].'&nbsp;</span></td>';
  }
}

$strWhere = '';
if ( $oSEC->type==2 && !$oVIP->IsStaff() ) $strWhere = ' AND t.firstpostuser='.$oVIP->id;
if ( $_SESSION[QT]['show_closed']=='0' ) $strWhere.=' AND t.status<>"Z"'; 

// BUTTON LINE AND PAGER

$oDB->Query( 'SELECT count(*) as countid FROM '.TABTOPIC.' t WHERE t.forum='.$oSEC->id.$strWhere );
$row = $oDB->Getrow();
$intCount = $row['countid'];
$strPager = MakePager("$oVIP->selfurl?s=$oSEC->id&amp;order=$strOrder&amp;dir=$strDirec",$intCount,$_SESSION[QT]['topics_per_page'],$intPage);
if ($strPager!='') $strPager = $L['Page'].$strPager;

// BUTTONS

$strCommand = ( QTI_BACKBUTTON ? '<td class="button" style="width:20px"><a href="'.$oVIP->exiturl.'" class="button">'.QTI_BACKBUTTON.'</a></td>' : '').N.$strCommand.N.'<td></td>';

// Moderator Actions

if ( $oVIP->IsStaff() )
{
$arr = array('views'=>$L['Views'],'status'=>$L['Status'],'actorname'=>$L['Userrole_MA']);
if ( $oSEC->wisheddate!=0 ) $arr['wisheddate']=$L['Wisheddate'];
if ( $oSEC->notifycc!=0 ) $arr['notifiedname']=$L['Userrole_UN'];
if ( !empty($_SESSION[QT]['tags']) ) $arr['tags']=$L['Tags'];
echo '
<form method="post" action="qti_topics.php?s=',$s,'" id="modaction">
<div class="modboard">
<span class="modboard">',$L['Userrole'][$oVIP->role],' <input type="hidden" name="s" value="',$oSEC->id,'"/>
<select name="Maction" class="small" onchange="document.getElementById(\'action_ok\').click();">
<option value="">',S,'</option>
<option value="nt">',$L['Post_new_topic'],'...</option>
<option value="" disabled="disabled">---------------</option>
<option value="show_Z"',($_SESSION[QT]['show_closed'] ? ' class="bold"' : ''),'>',$L['Topic_closed_show'],'</option>
<option value="hide_Z"',(!$_SESSION[QT]['show_closed'] ? ' class="bold"' : ''),'>',$L['Topic_closed_hide'],'</option>
</select> ',$L['Last_column'],S;
echo '<select id="d_last" name="d_last" class="small" onchange="document.getElementById(\'action_ok\').click();">';
echo '<option value="">',S,'</option>';
echo QTasTag($arr,'',array('current'=>$oSEC->d_last,'classC'=>'bold'));
echo '<option value="-" disabled="disabled">---------------</option>
<option value="none"'.($oSEC->d_last=='none' ? ' class="bold"' : '').' class="small">('.$L['None'].')</option>
<option value="-" disabled="disabled">---------------</option>
<option value="modifdate" class="small">',$L['Modified'],'</option>
<option value="id" class="small">Id</option>
';
if ( $bMap ) echo '<option value="coord" class="small">',$L['Coord'],'</option>
';
echo '
</select> <input type="submit" name="Mok" value="',$L['Ok'],'" class="small" id="action_ok"/>
<script type="text/javascript">
<!--
document.getElementById("action_ok").style.visibility="hidden";
document.getElementById("action_ok").value="";
-->
</script>
</span>
</div>
</form>
';
}

// End Moderator actions

if ($_SESSION[QT]['section_desc']=='1')
{
  if (!empty($oSEC->descr)) echo '<!-- Section description -->',N,'<p id="sectiondesc">',$oSEC->descr,'</p>',N,'<!-- Section description -->',N,N;
}

echo '
<!-- Button and pager -->
<table class="button button_top" cellspacing="0">
<tr class="button">',N,$strCommand,N,'<td id="pager_zt">',$strPager,'</td>
</tr>
</table>
<!-- End button and pager -->
';

// DISPLAY

if ( $intCount==0 )
{
  echo '<br/>',$L['None'],'... ',$L['E_topic_private'],'<br/><br/>',N;
  include('qti_p_footer.php');
  exit;
}

// LIST TOPICS

// Last column: can be '0' (moderator requests no-field)
if ( !empty($_SESSION[QT]['lastcolumn']) ) $oSEC->d_last = $_SESSION[QT]['lastcolumn'];
switch($oSEC->d_last)
{
case 'replies': $str=$L['Replys']; break;
case 'views': $str=$L['Views']; break;
case 'status': $str=$L['Status']; break;
case 'wisheddate': $str=$L['Wisheddate']; break;
case 'id': $str='Id'; break;
case 'actorname': $str=$L['Userrole_MA']; break;
case 'notifiedname': $str=$L['Userrole_UN']; break;
case 'tags': $str=$L['Tags']; break;
case 'modifdate': $str=$L['Modified']; break;
case 'coord': $str=$L['Coord']; break;
default: $str=$oSEC->d_last;
}

echo '<table class="data_t" cellspacing="0">',N;
echo '<tr class="data_t">',N;

// ========
$arrFLD = array();
$oFLD = new cFLD('icon','&bull;'); $oFLD->uid='status';$oFLD->sort='ASC'; $oFLD->desc='class=th_t th_t_ico th_t_first'; $arrFLD['icon']=$oFLD;
$oFLD = new cFLD('numid',$L['Ref']);                   $oFLD->sort='DESC';$oFLD->desc='class=th_t th_t_ref;style=background-color:%bg'; if ( $oSEC->numfield!='N' ) $arrFLD['numid']=$oFLD;
$oFLD = new cFLD('smile','&nbsp;');                    $oFLD->sort=FALSE; $oFLD->desc='class=th_t th_t_smi'; if ( !empty($oSEC->prefix) ) $arrFLD['smile']=$oFLD;
$oFLD = new cFLD('title',$L['Topics']);                $oFLD->sort='DESC';$oFLD->desc='class=th_t th_t_tit'; $arrFLD['title']=$oFLD;
$oFLD = new cFLD('you','&nbsp;');                      $oFLD->sort=FALSE; $oFLD->desc='class=th_t th_t_inf;style=width:10px'; if ( QTI_LIST_ME ) $arrFLD['you']=$oFLD;
$oFLD = new cFLD('firstpostname',$L['Topic_starter']); $oFLD->sort='ASC'; $oFLD->desc='class=th_t th_t_inf;style=width:140px'; $arrFLD['firstpostname']=$oFLD;
$oFLD = new cFLD('lastpostdate',$L['Last_message']);   $oFLD->sort='ASC'; $oFLD->desc='class=th_t th_t_inf;style=width:140px'; $arrFLD['lastpostdate']=$oFLD;
if ( $oSEC->d_last=='none' || empty($oSEC->d_last) || $oSEC->d_last=='N' || $oSEC->d_last=='replies' )
{
$oFLD = new cFLD('replies',$L['Replys']);              $oFLD->sort='DESC';$oFLD->desc='class=th_t th_t_sta th_t_last;style=width:75px'; $arrFLD['replies']=$oFLD;
}
else
{
$oFLD = new cFLD('replies',$L['Replys']);              $oFLD->sort='DESC';$oFLD->desc='class=th_t th_t_sta;style=width:75px'; $arrFLD['replies']=$oFLD;
$oFLD = new cFLD($oSEC->d_last,$str);                  $oFLD->sort=($oSEC->d_last=='tags' ? FALSE : 'ASC');$oFLD->desc='class=th_t th_t_sta th_t_last'.($oSEC->d_last=='status' ? ';style=background-color:%bg' : ';style=width:80x'); $arrFLD[$oSEC->d_last]=$oFLD;
}
// ========
TableHeader($arrFLD,$intCount,"$oVIP->selfurl?s=$oSEC->id&amp;page=1",$strOrder,$strDirec);
// ========

echo '</tr>',N;

foreach($arrFLD as $strKey=>$oFLD) if ( !empty($oFLD->desc) ) { $oFLD->desc = str_replace('th_','td_',$oFLD->desc); $arrFLD[$strKey]=$oFLD; }
// ========
if ( QTI_LIST_ME && $oVIP->numpost>0 ) {
if ( $oSEC->replies>0 ) {
  $oDB->Query('SELECT topic,issuedate FROM '.TABPOST.' WHERE forum='.$s.' AND type="R" AND userid='.$oVIP->id);
  while($row=$oDB->Getrow()) $arrMe[intval($row['topic'])] = $row['issuedate'];
}}
// ========
$strState  = 't.*, p.title, p.icon, p.textmsg FROM '.TABTOPIC.' t INNER JOIN '.TABPOST.' p ON t.firstpostid=p.id WHERE t.forum='.$oSEC->id.$strWhere;
if ( $strOrder=='title' ) { $str='p.title'; } else { $str='t.'.$strOrder; }
if ( $_SESSION[QT]['news_on_top']==1 ) $str = 't.type ASC, '.$str;
$oDB->Query( LimitSQL($strState,$str.' '.$strDirec,$intLimit,$_SESSION[QT]['topics_per_page'],$intCount) );
// ========
$intWhile=0;
$strAlt='r1';
while($row=$oDB->Getrow())
{
  TableRow($arrFLD,$row,true,$oSEC,$strAlt,$bMap);
  if ( $strAlt=='r1' ) { $strAlt='r2'; } else { $strAlt='r1'; }

  $intWhile++; 
  //odbcbreak
  if ( $intWhile>=$_SESSION[QT]['topics_per_page'] ) break;  
}
// ========

echo '<tr class="tf_t">',N;
echo '<td class="tf_t tf_t_first"></td>',N;
For ($i=0;$i<(count($arrFLD)-2);$i++)
{
echo '<td class="tf_t"></td>',N;
}
echo '<td class="tf_t tf_t_last"></td>',N;
echo '</tr>
</table>
';

// BUTTON LINE AND PAGER

// define csv options according to $intCount (max 10000)

$strCsv ='';
if ( $oVIP->role!='V' )
{
  if ( $intCount<=$_SESSION[QT]['topics_per_page'] )
  {
  $strCsv = '<a href="qti_topics_csv.php?s='.$s.'&amp;size=all&amp;n='.$intCount.'" class="a_csv">csv</a>';
  }
  else
  {
  $strCsv = '<a href="qti_topics_csv.php?s='.$s.'&amp;size=p'.$intPage.'&amp;n='.$intCount.'&amp;order='.$strOrder.'&amp;dir='.$strDirec.'" class="a_csv">csv <span class="small">('.strtolower($L['Page']).')</span></a>';
  if ( $intCount<=1000 )                   $strCsv .= ' &middot; <a href="qti_topics_csv.php?s='.$s.'&amp;size=all&amp;n='.$intCount.'&amp;order='.$strOrder.'&amp;dir='.$strDirec.'" class="a_csv">csv <span class="small">('.strtolower($L['All']).')</span></a>';
  if ( $intCount>1000 && $intCount<=2000 ) $strCsv .= ' &middot; <a href="qti_topics_csv.php?s='.$s.'&amp;size=m1&amp;n='.$intCount.'&amp;order='.$strOrder.'&amp;dir='.$strDirec.'" class="a_csv">csv <span class="small">(1-1000)</span></a> &middot; <a href="qti_topics_csv.php?s='.$s.'&amp;size=m2&amp;n='.$intCount.'" class="a_csv">csv <span class="small">(1000-'.$intCount.')</span></a>';
  if ( $intCount>2000 && $intCount<=5000 ) $strCsv .= ' &middot; <a href="qti_topics_csv.php?s='.$s.'&amp;size=m5&amp;n='.$intCount.'&amp;order='.$strOrder.'&amp;dir='.$strDirec.'" class="a_csv">csv <span class="small">(1-5000)</span></a>';
  if ( $intCount>5000 )                    $strCsv .= ' &middot; <a href="qti_topics_csv.php?s='.$s.'&amp;m=5&amp;n='.$intCount.'&amp;order='.$strOrder.'&amp;dir='.$strDirec.'" class="a_csv">csv <span class="small">(1-5000)</span></a> &middot; <a href="qti_topics_csv.php?s='.$s.'&amp;m=10&amp;n='.$intCount.'" class="a_csv">csv <span class="small">(5000-10000)</span></a>';
  }
}
if ( !empty($strCsv) )
{
  $strPager = $strCsv.' &middot; '.$strPager;
  if ( substr($strPager,-10,10)==' &middot; ' ) $strPager = substr($strPager,0,-10);
}

// display button, pager and csv

if ( $intCount>2 )
{
echo '
<!-- Button and pager -->
<table class="button button_bot" cellspacing="0">
<tr class="button">',N,$strCommand,N,'<td id="pager_zb">',$strPager,'</td>
</tr>
</table>
<!-- End button and pager -->
';
}
else
{
echo '<p class="csv">',$strPager,'</p>';
}

// TAGS FILTRING

if ( QTI_LIST_TAG && !empty($_SESSION[QT]['tags']) )
{
  require_once('bin/qti_fn_tags.php');
  $arrTags = $oSEC->GetTagsUsed($s,50);
  if ( count($arrTags)>0 ) 
  {
    if ( count($arrTags)>5 ) 
    {
    echo '<p class="tagbox">'.$L['Show_only_tag'],'</p><div class="tagbox">';
    foreach($arrTags as $strTag)
    {
      echo '<a class="tag',(count($arrTags)>12 ? ' small' : ''),'" href="qti_search_re.php?a=tst&amp;s=',$s,'&amp;y=',date('Y'),'&amp;k1=-1&amp;k2=-1&amp;k3=',$strTag,'">',$strTag,'</a>&nbsp; ';
    }
    echo '</div>';
    }
    else
    {
    echo '<p class="tagline">'.$L['Show_only_tag'];
    foreach($arrTags as $strTag)
    {
      echo ' <span class="tagline" title=""><a class="tag" href="qti_search_re.php?a=tst&amp;s=',$s,'&amp;y=',date('Y'),'&amp;k1=-1&amp;k2=-1&amp;k3=',$strTag,'">',$strTag,'</a></span>';
    }
    echo '</p>';
    }
  }
}

// MAP MODULE

if ( $bMap )
{
  if ( count($arrExtData)==0 )
  {
  echo '<p class="gmap">'.$L['map']['E_noposition'].'</p>';
  }
  else
  {
     //select zoomto (maximum 15 items in the list)
     if ( count($arrExtData)>1 )
     {
       $str = '<p class="gmap" style="margin:0 0 4px 0"><a class="gmap" href="javascript:void(0)" onclick="zoomToFullExtend(); return false;">'.$L['map']['zoomtoall'].'</a> | '.$L['Goto'].' <select class="gmap" id="zoomto" name="zoomto" size="1" onchange="map.setCenter(eval(this.value));">';
       $str .= '<option class="gmap" value="new GLatLng('.QTgety($_SESSION[QT]['m_map_gcenter']).','.QTgetx($_SESSION[QT]['m_map_gcenter']).')"> </option>';
       $i=0;
       foreach($arrExtData as $intKey=>$oMapPoint)
       {
       $str .= '<option class="gmap" value="new GLatLng('.$oMapPoint->y.','.$oMapPoint->x.')">'.$oMapPoint->title.'</option>';
       $i++; if ( $i>15 ) break;
       }
       $str .= '</select></p>';
     }

  echo '
  <table class="hidden" style="margin-top:5px;">
  <tr class="hidden">
  <td class="gmap">
  ';
  if ( count($arrExtData)>1 && !$_SESSION[QT]['m_map_hidelist'] ) echo $str;
  if ( !$_SESSION[QT]['m_map_hidelist'] )
  {
  echo '<div id="map_canvas" style="width:100%; height:350px;"></div>';
  }
  echo '
  <p class="gmap" style="margin:4px 0 0 0">',sprintf($L['map']['items'],strtolower( LangS('Topic',count($arrExtData))),strtolower(LangS('Topic',$oSEC->topics)) ),'</p>
  ';
  echo '</td>
  </tr>
  </table>
  ';
  }
  if ( count($arrExtData)!=0 )
  {
    if ( $_SESSION[QT]['m_map_hidelist'] ) 
    {
    echo '<p style="margin:2px"><a href="',$oVIP->selfurl,'?s=',$s,'&amp;showmap">',$L['map']['Show_map'],'</a></p>';
    }
    else
    {
    echo '<p style="margin:2px"><a href="',$oVIP->selfurl,'?s=',$s,'&amp;hidemap">',$L['map']['Hide_map'],'</a></p>';
    }
  }
}

// ---------
// HTML END
// ---------

// MAP MODULE

if ( $bMap )
{
  if ( count($arrExtData)>0 ) { include('qtim_map_load.php'); } else { echo '<script type="text/javascript">function GUnload() { return true; }</script>'; }
}

include('qti_p_footer.php');

?>